﻿/*
Auteur:   Martin Robinson
Travail:  regular expression
html:     xhtml 1.0
css:      2.1

     /
 ('<
(<=)
*/

/*------------------------------------------------------------------------------
constante des ragex  pour valider les entré utilisateur
------------------------------------------------------------------------------*/
var regexById = new Array();
regexById["phone"] = new RegExp("^((\\d{3})[\\-\\.](\\d{3})\\2(\\d{4}))|((\\(\\d{3}\\)\\s?)?(\\d{3})[\\.\\-](\\d{4}))$");
regexById["cp"] = new RegExp("^(\\D\\d\\D(\\s|\\-)?\\d\\D\\d)$","i");
regexById["date"] = "^\\d{4}([\\-\\/])(0([1-9])|1([0-2]))\\1(([0-2]?\\d)|(3[0-1]))$|^(([0-2]?\\d)|(3[0-1]))\\s\\D{3,9}\\s\\d{4}$";
//regexById["date"] = new RegExp("^(((((19)|(20))\\d{2})(\\-|/)((1[0-2])|(0?\\d))\\5(([012]?\\d)|(3[01])))|(((3[01])|([012]?\\d))\\s((((janv)|(fevr))ier)|(ma((rs)|i))|(a((vril)|(out)))|(jui(n|(llet)))|(((((dec)|(sept)|(nov))em)|(octo))bre))\\s(((19)|(20))\\d{2})))$","i");
regexById["nas"] = new RegExp("^(\\d{3})(\\-|\\s)?(\\d{3})\\2(\\d{3})$");
regexById["email"] = new RegExp("^\\w+@(((((1?\\d)?\\d)|(2[0-4]\\d)|(25[0-5]))(\\.(((1?\\d)?\\d)|(2[0-4]\\d)|(25[0-5]))){3})|(\\w+(\\.\\w+)?))$", "i");
regexById["url"] = new RegExp("^(((http)|(ftp))s?://)((w{3}\\.)?(\\w+(\\.\\w+)?))((w{3}\\.)?(\\w+(\\.\\w+)?))(/\\w*)+$", "i");
regexById["decimal"] = new RegExp("^\\d+[,\\.]\\d*$");
regexById["virgule"] = new RegExp("^\\d+,\\d*$");

/*------------------------------------------------------------------------------
constante des messages à laissé a l'utilisateur
------------------------------------------------------------------------------*/
var msgById = new Array();
msgById["phone"] = "le numéro de téléphone doit être de la façon suivante:\n [999-9999] [999.9999] [999-999-9999] [999.999.9999] [(999) 999-9999] [(999)999-9999] [(999) 999.999] [(999)999.9999]";
msgById["cp"] = "le code postal doit être écrit de la façon suivante:\n [j9p 1pd] [j9p 1j1] [a1p1o1] [j9p 1s5] [j9p-1s5]";
msgById["date"] = "la date doit être écrit de la façon suivante:\n [aaaa-mm-jj] [aaaa/mm/jj] [j mmmm aaaa] [jj mmmm aaaa]";
msgById["nas"] = "le numéro d'assurance social doit être écrit de la façon suivante:\n [999 999 999] [999-999-999] [999999999]";
msgById["email"] = "l'addresse courriele doit être écrit de la façon suivante:\n compte@domain.ext compte@[ip]";
msgById["url"] = "l'addresse web doit être écrit de la façon suivante:\n protocole://addresse";
msgById["decimal"] = "la valeur décimale doit être écrit de la façons suivante:\n XX.XX";
msgById["virgule"] = "la virgule à été remplacé par un point";


/******************************************************************************/
function Valider(elementID)
/******************************************************************************/
/* pour lélément donné , validé le contenu avec le regex prévu a cet éffet    */
/* cette fonction laisse tomber si l'élément est laissé vide                  */
/******************************************************************************/
{
  var element = document.getElementById(elementID);
  if (element.value.length==0)
  {
    return true;
  }
  if (!regexById[elementID].test(element.value)){
    alert(msgById[elementID]);
    element.focus();
    element.select();
    return false;
  }
  return true;
}

/******************************************************************************/
function FormulaireComplet()
/******************************************************************************/
/* verification de chaque element du formulaire a savoir s'il ont tous été    */
/* completé                                                                   */
/******************************************************************************/
{
  var elementManquant = "les éléments suivants sont manquants \n";
  var ilEnManque = false;
  var element;
  //pour chaque élément couvert par les regex
  for(elementID in regexById)
  {
    element = document.getElementById(elementID);
    //si l'élément est vide
    if (element.value.length==0)
    {
      elementManquant += elementID + "\n";
      if (!ilEnManque)
      {
        ilEnManque = true;
        element.focus();
        element.select();
      }
    }
  }
  //est-ce qu'il en manque au moin un
  if (ilEnManque)
  {
    alert(elementManquant);
  }
}

/******************************************************************************/
function Virgule()
/******************************************************************************/
/*fonction magique qui remplace les virgules en points dans un nombre decimal */
/******************************************************************************/
{
  var element = document.getElementById("decimal");
  if (regexById["virgule"].test(element.value))
  {
    element.value = element.value.replace(/,/g,".");
    alert("la vigule a été remplacé par un point");
  }
}

